"""
_MotT0Detail Page_
This page show just 1 table
 
""" 
from WMCore.WebTools.Page import TemplatedPage

from Table import *
from TableContents import *
from MotT0 import MotT0Page

class MotT0Detail(MotT0Page):
    title="MotT0 detailed page"
    table=""
    run=""
    status=""
    
    def __init__(self, motT0Template,kwords):
      self.motT0Template=motT0Template
      self.DASUrl=motT0Template.config.DAS
      self.templatedir = motT0Template.templatedir+'/'
      self.params=kwords
      #self.templatedir = templatedir
      #generate code for tables
    
      
      
    def getTemplate(self):
       try:
        tableName=self.params['table']
        self.status=self.params['status']
        try:
         self.run=self.params['run_id']
         r=int(tableRun)
        except:
         pass
        #self.params=self.params.update({status})
        contents=[exprJByStatus(self.params),
                exprMJByStatus(self.params),
                repkJByStatus(self.params),
                repkMJByStatus(self.params),
                recoJByStatus(self.params),
                recoMJByStatus(self.params),
                alcaJByStatus(self.params),
                alcaMJByStatus(self.params),
                ] 
        for cont in contents:
          #print "checking "+ cont.name+"   "+tableName 
          if cont.name==tableName:
             self.table=cont.name
                    
       except ConnectionException, e:
        print str(e)
        pass
          
       params={
            "page": "detail",
            "title": self.title,
            "time" : ctime(),
            "tmplPath": self.templatedir,
            "table": self.table,
            "run": self.run,
            "status":self.status
              }
       return self.motT0Template.templatepage('detail', **params )
    
    