import os,time,random,socket,urllib,json,cherrypy,calendar
from Utils import *
from SeriesLib import *

#EMPTY_PLOT_IMG="imgs/emptyPlot.jpeg"

#jsScript="""
#<script type="text/javascript">
   #var loadingImage = false;
   #function LoadImage(imageName,imageFile)
      #{
       #if ((!document.images) || loadingImage) return;
          #loadingImage = true;
          #if (document.images[imageName].src.indexOf(imageFile)<0)
                #{
                #document.images[imageName].src = imageFile;
               #}
         #loadingImage = false;
      #}
#</script> """

#def plotsToImgs(plots,plotfairyUrl,startTime,emptyPlotMessage="<B> Empty Plot</B> <BR/> Not enough input data"):
      #"""
      #This method takes a dictionary of plot objects: process them, save them and prepare the HTML code to link them to queve of serial plotfairy requests.
      #The result of the method is a dictionary with the same keys of the input one and with values the HTML code, for every plot.
      #"""
      #plotImgs={} #parameters list
      #first=None
      #nameList=plots.keys()
      #option=str(random.randint(0,255)) # disable brawser caching
      #urls={}
      ###build series, save json to disk, save resulting urls 
      #for name in nameList:
        ##print "---------------------"+str(name)+"---------------"
        #fileName="jsonData-"+str(name)+"-"+option+"-"+str(startTime)+".json"
        #plots[name].saveData(fileName)
        #urls.update({name:plots[name].getUrl(plotfairyUrl)})
        
        
      ### drop empty plots  
      #for name in nameList:
        #if urls[name]=="":
           #plotImgs.update({name:emptyPlotMessage}) 
           #del urls[name]
           
      #### set order chain
      #nameList=urls.keys()
      #for i in range(0,len(nameList)):
       #currentName=nameList[i]
       ##plot= plots[currentName]
       #if first==None: first = currentName
       #try:
          #nextName=nameList[i+1]
          #img= getImage(currentName,nextName,urls[nextName])
          ### image dimensions on CSS
       #except Exception, e:
          ##last image
          #img=getImage(currentName,"","")
       #plotImgs.update({currentName:img})
       
      ### add script to the parameters list
      #if first!=None: 
        #plotImgs.update({"script": jsScript+"""<script>LoadImage('%s','%s');</script> """%(first,urls[first])})
      #else: 
        #plotImgs.update({"script": ""})
      #return plotImgs

#def getImage(current,next,nextImageUrl):
   #if next!="":
     #img="""<img name="%s" border="0" onLoad="LoadImage('%s','%s')">"""%(current,next,nextImageUrl)
   #else:
     #img="""<img border="0" name="%s">""" %(current)
   #return """<a href="" class="rollover"> """+img+"</a>"

#############################################################################################################
def dateForm(target,dtime,currentLength,hoursRange,currentStep=None, stepRange=None,run=None,hiddenValues=""):
  """
  This method produces a standard form for deciding the plot options.
  According with the (optional) parameters some comboboxes are showed (and others are not) 
  """
  #print "TIME="+str(dtime.hour)+" and" +str(dtime.minute)
  if dtime.minute>0:
    from datetime import timedelta 
    dtime=dtime+timedelta(minutes=(60-dtime.minute))
    #if currentLength!=None:currentLength+=1
  form=""" <form name="%sForm" action="" method="POST"><fieldset>
            <legend>Plot options:</legend>
            Show the previous:
            <select name="hours">"""%(target)
  for i in hoursRange:
    selected=""
    if i==currentLength: selected="selected=\"selected\"" 
    form+="""<option value="%d" %s>%d</option>"""%(i,selected,i)
  form+="""</select> hour(s)"""
  if currentStep!=None:
    form+=""" in intervals of: <select name="step">"""
    for i in stepRange:
       selected=""
       if i==currentStep: selected="selected=\"selected\""
       form+="""<option value="%d" %s>%d</option>"""%(i,selected,i)
    form+="""</select> minutes """
    
  form+="""<BR/>  with an end time of: <select name="sh"> """
 
  for i in range(1,24+1):
    selected=""
    if i==dtime.hour: selected="selected=\"selected\"" 
    form+="""<option value="%d" %s>%d:00</option>"""%(i,selected,i)
  form+= """</select>  of:
            <select name="sd">"""
  for i in range(1,31+1):
    selected=""
    if i==dtime.day: selected="selected=\"selected\"" 
    form+="""<option value="%d" %s>%d</option>"""%(i,selected,i)
  form+="""</select>
             <select name="sm">"""
  for i in range(1,12+1):
    selected=""
    if i==dtime.month: selected="selected=\"selected\"" 
    form+="""<option value="%d" %s>%s</option>"""%(i,selected,calendar.month_name[i])
  form+="""</select>
             <select name="sy">"""
  for i in range(2010,dtime.year+1):
    selected=""
    if i==dtime.year: selected="selected=\"selected\""
    form+="""<option value="%d" %s>%d</option>"""%(i,selected,i)
  form+="""</select>"""
  
  if run!=None: 
    form+="""<input type="hidden" name="run_id" value="%d">"""%(run)
  form+=hiddenValues
  form+="""<BR/> <div align="center">
         <input type="button" value="Update Plot(s)" onClick="javascript:processForm('%s')" /> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
         <input type="button" value="Reset to Default Plot(s)" onClick="javascript:processForm('%s','True')" /></div>
        </fieldset></form>"""%(target,target)
  return form

########################################################################################################### Plot objects
from types import *
import urllib2

class EmptyPlotException(Exception):
  pass

class Plot(object):
   ptype=''
   def __init__(self,plotfairyUrl,inputSeries=None,legenda=None,):
      self.inputSeries=inputSeries
      self.legenda=legenda
      self.loadingURL=""
      self.enoughData=False
      self.plotfairyUrl=plotfairyUrl

   def saveData(self,fileName=""):
        ## json object may be grater then 255 char of the URL, so I store them and prepare them to be fetched by plotfairy
       self.buildPlotData() ## special processing/upgrade of the local plotTemplate
       self.fileName=fileName
       #print "saving..."
       if not(self.enoughData): 
          #print "DATA="+str(self.plotTemplate)
          raise EmptyPlotException()
          return
       saveDataInFile(json.dumps(self.plotTemplate),fileName)
       url=urllib.quote("http://"+socket.gethostname()+":"+str(cherrypy.config['server.socket_port'])+"/T0Mon/static?file=%s"%(self.fileName))
       #print "PLOTFAIRY=========="+self.plotfairyUrl+"plot/?type=%s&url=%s"%(self.ptype,url)
       self.response = urllib2.urlopen(self.plotfairyUrl+"plot/?type=%s&url=%s"%(self.ptype,url))
       image=self.response.read()
       saveDataInFile(image,fileName+'.png')
         
         
   def buildPlotData():
     pass
     
      
      
   
############################################################################################################################### Scatter
class ScatterPlot(Plot):
   ### support only for DatasetSeries [the methods access private DatesetSeries fields] 
   ptype='Scatter'
   marker="o"
   plotTemplate={ "draw_lines": False,  
                "legend": "bottomleft",
                "xaxis": {
                        "format": "time", 
                        "label": "time" }, 
                "yaxis": {
                        "format": "num", 
                        "label": "",
                        "log": True 
                         }}
                         
   def makeTitle(self,hours,interval):
     self.title=self.title%(hours,interval)
                          
   def buildPlotData(self):
      self.series=[]
      for (name,d) in self.inputSeries.iteritems():
          if ('log' in self.plotTemplate['yaxis']) and self.plotTemplate['yaxis']['log']:
             x,y= self.clearZeroValues(getattr(d,self.xAttr),getattr(d,self.yAttr))
          else:
            x=getattr(d,self.xAttr)
            y=getattr(d,self.yAttr)
          
          if len(getattr(d,self.xAttr))!=len(getattr(d,self.yAttr)): 
            print "error: different data length!!"+self.xAttr+"  "+self.yAttr
            
          if len(getattr(d,self.xAttr))>0:
            self.enoughData=True
            self.series.append({ 
                "colour": self.legenda.getColor(name), 
                "label": name, 
                "marker": self.marker, 
                "x": x, 
                "y": y })
      self.plotTemplate.update({"series": self.series,"title": self.title})
      self.plotTemplate['yaxis']['label']=self.yLabel
      

   def clearZeroValues(self,x,y):
       if len(x)!=len(y): 
            print "error: different data length"
            return x,y
       xx=[]
       yy=[]
       for i in range(0,len(x)):
           if y[i]>0.0001:
               xx.append(x[i])
               yy.append(y[i])
       return xx,yy
      
##################################
class eventsPlot(ScatterPlot):
    title="Event Rate [%dh] - AVG on %d-min intervals"
    yLabel="Hz"
    xAttr="eventsIntervalX"
    yAttr="eventsIntervalY"

    
class eventSizesPlot(ScatterPlot):
    title="Event Sizes Over Time [%dh] - AVG on %d-min intervals"
    yLabel="KB"
    xAttr="eventSizesX"
    yAttr="eventSizesY"   

class dataRatePlot(ScatterPlot):
    title="Data Rate Over Time [%dh] - AVG on %d-min intervals"
    yLabel="MB/s"
    xAttr="dataRateX"
    yAttr="dataRateY"
    
    def makeTitle(self,hours,interval):
     #dataRatePlot has always a interval [and the smaller is 1 minute]
     self.title=self.title%(hours,max(interval,1))    
##########################################3
## events and eventSize plot WITHOUT INTERVAL [raw data]
class eventsPlotNoInt(ScatterPlot):
    title="Event Rate [%dh]"
    yLabel="Hz"
    xAttr="X"
    yAttr="Y"
    def makeTitle(self,hours,step):
     self.title=self.title%(hours)
    
class eventSizesPlotNoInt(eventsPlotNoInt):
    title="Event Sizes Over Time [%dh]"
    yLabel="KB"
    xAttr="X"
    yAttr="allEventSizesY"   


    
#class PiePlot(Plot):
    #ptype="Pie"
    
    #def buildPlotData(self):
      #self.title=self.title%(self.interval)
      #self.series=[]
      #for (name,d) in self.inputSeries.iteritems():
          #self.series.append({ 
            #"colour": self.legenda.getColor(name), 
            #"label": name, 
            #"value": getattr(d,'count'), 
            #})
      #self.plotTemplate.update({"series": self.series,"title": self.title})
      
################################################################################################### BAR   -- plots
class barPlot(Plot):
  enoughData=True
  ptype='Bar'
  plotTemplate={
    #"legend": "bottomleft", 
    "series": [
        {
            "colour": "#46cf51",  
            "values": []
        }
    ], 
    "sort": "value", 
    "title": "UpdateMe", 
    "xaxis": {
        "bins": None, 
        "format": "time", 
        "label": "Time", 
        "min": None,
        "max": None, 
        "width": None
    }, 
    "yaxis": {
        "format": "dec", 
        "label": "AVG # of job", 
        "log": False
    }
}
  def buildPlotData(self):
     dataSize=len(self.inputSeries.getYValues())
     #check data
     for i in self.inputSeries.getYValues():
       if i>0:
         self.enoughData=True
         break

     if dataSize>0 and self.enoughData:
       #print "PLOT=="+str(self.inputSeries.getYValues())
       self.plotTemplate['series'][0]['values']=self.inputSeries.getYValues()
       self.plotTemplate['series'][0]['colour']=self.color
       self.plotTemplate['xaxis']['bins']=dataSize
       self.plotTemplate['xaxis']['min']=self.inputSeries.minValue
       self.plotTemplate['xaxis']['max']=self.inputSeries.maxValue
       self.plotTemplate['xaxis']['width']=self.inputSeries.INTERVAL
       self.plotTemplate['title']=self.title
       #self.plotTemplate['xaxis']['label']=self.xaxisLabel
     
     
class expressBarPlot(barPlot):
  title="Express Jobs"
  color="#e0ffff"
  
class expressmergeBarPlot(barPlot):
  title="Express Merge"
  color="#e0ffff"
  
class repackBarPlot(barPlot):  
  title="Repack Jobs"
  color="#FFEFD5"
  
class repackmergeBarPlot(barPlot):  
  title="Repack Merge Jobs"
  color="#FFEFD5"

class recoBarPlot(barPlot):  
  title="Reco Jobs"
  color="#F0FFF0"
  
class recomergeBarPlot(barPlot):  
  title="Reco Merge Jobs"
  color="#F0FFF0"
  
class alcaBarPlot(barPlot):  
  title="Alca Jobs"
  color="#FFFFE0"
  
class alcamergeBarPlot(barPlot):  
  title="Alca Merge Jobs"
  color="#FFFFE0"
  
class allJobsBarPlot(barPlot):  
  title="All Jobs"
  color="#00A000"
########################################################################################################    
#class jobPlot(ScatterPlot):
    #marker="*"
    #title="Job Plot [%dh]"
    #yLabel="# starting jobs"
    #xAttr="X"
    #yAttr="Y"
    #plotTemplate={ "draw_lines": True,
                   #"legend": "left",   
                #"xaxis": {
                        #"format": "time", 
                        #"label": "time" }, 
                #"yaxis": {
                        #"format": "num", 
                        #"label": "",
                        #"log": False 
                         #}}

                         
#class jobStatPiePlot(PiePlot): ## pie
    #title="Job Statuses [%dh]"
    #plotTemplate=   {
    #"labels": True, 
    #"legend": "left", 
    #"percentage": True, 
    #"shadow": True, 
    #"sort": "label_reverse"}
########################################################################################################    
class Legend(object):
    
     def __init__(self,set):
         self.colors={}
         for d in set:
             self.colors.update({d:self.random_color()})
             
     def random_color(self):
       return '#%02x%02x%02x'%(random.randint(0,255),random.randint(0,255),random.randint(0,255))
     
     def getColor(self,name):
         return self.colors[name]
    
     def getHTML(self):
        res="<BR/><BR/><BR/><BR/><B>Legenda:</B><BR/><BR/>"
        for k,v in self.colors.items():
            res+="""<B><FONT COLOR="%s">%s</FONT></B><BR/>"""%(v,k)
        return res
      
############################################################################# 
   

